﻿using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Pathing;
using Styx.Plugins;
using Styx.WoWInternals;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace eUnstuck
{
    public class plugin : HBPlugin
    {
        public override string Author
        {
            get { return "erenion"; }
        }

        public override string Name
        {
            get { return "eUnstuck"; }
        }

        public override string ButtonText
        {
            get
            {
                return "Nada";
            }
        }

        public override Version Version
        {
            get { return new Version(1,0); }
        }

        public override bool WantButton
        {
            get
            {
                return false;
            }
        }
        public override void OnButtonPress()
        {
        }

        public override void Pulse()
        {
            if (Navigator.NavigationProvider.StuckHandler.GetType() != typeof(eUnstuck))
            {
                Navigator.NavigationProvider.StuckHandler = new eUnstuck(Navigator.NavigationProvider.StuckHandler);
                Logging.Write("eUnstuck overwrote another loaded unstuck method.");
            }
        }

    }

    public class eUnstuck : IStuckHandler
    {
        IStuckHandler old;
        public eUnstuck(IStuckHandler stuckHandlerWithIsStuck)
        {
            old = stuckHandlerWithIsStuck;
        }

        public bool IsStuck()
        {
            bool s = old.IsStuck();
            return s;
        }

        public void Reset()
        {
            old.Reset();
        }

        bool lastRight = false;
        public void Unstick()
        {
            Logging.Write("eUnstuck: Stuck, attempting to unstuck");
            StyxWoW.Me.SetFacing((float)((Math.PI + StyxWoW.Me.Rotation) % (2 * Math.PI)));
            Thread.Sleep(1000);
            WoWMovement.Move(WoWMovement.MovementDirection.Forward);
            Thread.Sleep(750);
            WoWMovement.Move(lastRight ? WoWMovement.MovementDirection.TurnLeft : WoWMovement.MovementDirection.TurnRight);
            lastRight = !lastRight;
            Thread.Sleep(1300);
            WoWMovement.MoveStop();
            Logging.Write("eUnstuck: Unstuck Complete");
        }

    }
}
